%{
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#ifdef VMS
#include <ssdef.h>
#else
#define SS$_NORMAL 1
#endif

#if !defined(TRUE)
#define TRUE  (1==1)
#define FALSE (!TRUE)
#endif

void	print_help();
char    *CHKZ();
char	VERSION[]="V1.1";
char	UPDATED[]="28-May-1999";
short int lowerc=TRUE;
short int mode=1;

#define CHECKIT  if(mode > 2 && ! lowerc) lowerc = TRUE

%}



%%
[[:space:]]		if(mode == 4) lowerc = FALSE; fprintf(yyout,yytext); 
[.!?]			if(mode > 2)  lowerc = FALSE; fprintf(yyout,yytext); 
[(){}\[\]]		if(mode == 4)  lowerc = FALSE; fprintf(yyout,yytext); 
"%"			fprintf(yyout,"%%");CHECKIT;		/* % in C  */
\134|\042		fprintf(yyout,"\%s",yytext);CHECKIT; 	/* \ and " */
.			fprintf(yyout,"%s",CHKZ(yytext));CHECKIT; 
<<EOF>>			yyterminate();
%%


int main(int argc,char **argv )
{
int i;

 for(i=1 ; i < argc ; i++){
	if(strcmp(argv[i],"-l") == 0)		mode = 1;
	else if(strcmp(argv[i],"-u") == 0)	mode = 2;
	else if(strcmp(argv[i],"-s") == 0)	mode = 3;
	else if(strcmp(argv[i],"-w") == 0)	mode = 4;
	else if(strcmp(argv[i],"-h") == 0) 	print_help(argv);
	else {
	 	if( ! yyin ) yyin = fopen( argv[i], "r" );
		else yyout = fopen( argv[i], "w" );
	}
 }
 if ( mode != 1) lowerc = FALSE;

 yylex();

}


void checkit()
{			
}


void print_help(char **argv)
{
char    *p_nom                  ;

#ifdef VMS
 p_nom   = strrchr(argv[0], ']');
#else
 p_nom   = strrchr(argv[0], '/');
#endif
 p_nom   = &p_nom[1];
 printf("\nCHTEXT version %s. Copyright (C) 1999 Jrme LAURET\n\n",VERSION);
 printf("This program modifies a regular ASCII text file content.\n");
 printf("It has been written in Flex V%d.%d. Last update %s\n",
	YY_FLEX_MAJOR_VERSION,YY_FLEX_MINOR_VERSION,UPDATED);
 printf("\nUsage is : $ %s [options] [InputFile] [OutputFile]\n",p_nom);
 printf("Options are :\n");
 printf("   -h     shows this help\n");
 printf("   -l     lowercase (default)\n");
 printf("   -u     Uppercase\n");
 printf("   -s     Sentence capitalize\n");
 printf("   -w     Word capitalize\n\n");

 printf("If you have any  suggestions, comments, or updates to this  utility,\n");
 printf("please Email me at jlauret@mail.chem.sunysb.edu.\n\n");
 exit(SS$_NORMAL);
}




char    *CHKZ(char *p)
{
char *q;

	q = p;
	while( *q ){
		if(lowerc){
			*q = tolower((int)*q);
		} else {
			*q = toupper((int)*q);
		}
		q++;
	}
	return  p;
}

