!! Program Name            : DESCRIP.MMS
!!   Original Author       : JLAURET
!!   Date                  : 27-May-1999
!!   Program Description   :  VMS Make file for CHTEXT
!!                         : 


! In case you have flex installed somewhere else, use
! /MACRO=(FLEXLIB=WhereverOLBIs,FLEXINC=WhereverHAre)
FLEXLIB	  = SYS$LIBRARY:flexlib.olb
FLEXINC	  = SYS$LIBRARY:


.ifdef __AXP__
EXE	  = EXE_AXP
OBJ       = OBJ_AXP
CFLAGS    = /prefix=ALL/standard=vaxc/g_float
LINKFLAGS = ,$(FLEXLIB)/lib
.else
EXE	  = EXE_VAX
OBJ       = OBJ_VAX
CFLAGS 	  = /g_float/include=($(FLEXINC))
LINKFLAGS = ,$(FLEXLIB)/lib,sys$Library:vaxcrtl/lib
.endif


CHTEXT.$(EXE) : CHTEXT.$(OBJ)
	LINK/EXEC=$(MMS$TARGET) CHTEXT.$(OBJ) $(LINKFLAGS)


CHTEXT.$(OBJ) : CHTEXT.C
	CC $(CFLAGS)/OBJECT=$(MMS$TARGET) $(MMS$SOURCE)

CHTEXT.C : CHTEXT.FLEX
	FLEX CHTEXT.FLEX
	RENAME LEXYY.C CHTEXT.C

CLEAN :
	@ IF f$SEARCH("LEXYY.C").nes."" then delete/nolog/noconf LEXYY.C;*
	@ IF f$SEARCH("CHTEXT.C").nes."" then delete/nolog/noconf CHTEXT.C;*
	@ IF f$SEARCH("CHTEXT.$(OBJ)").nes."" then delete/nolog/noconf CHTEXT.$(OBJ);*

